import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState, useEffect, useRef } from 'react';
import { Button, Card, CardBody, CardHeader, Heading, Stack, Text } from '@chakra-ui/react';
import { VoiceRecorder as CapacitorVoiceRecorder } from 'capacitor-voice-recorder';
import { useRecordingStatus } from '../hooks/use-recording-status';
import { useRecordingCycle } from '../hooks/use-recording-cycle';
import { useContainer } from '../hooks/use-container';
import { startRecording } from '../strart-recording';
import { stopRecording } from '../stop-recording';
import { downloadRecords } from '../download-records';
export function VoiceRecorder({ deep }) {
    const [recording, setRecording] = useState(false);
    const [records, setRecords] = useState([]);
    const [arePermissionsGranted, setArePermissionsGranted] = useState(undefined);
    const [canDeviceRecord, setCanDeviceRecord] = useState(undefined);
    useEffect(() => {
        new Promise(async () => {
            const { value: canDeviceRecord } = await CapacitorVoiceRecorder.canDeviceVoiceRecord();
            setCanDeviceRecord(canDeviceRecord);
        });
    }, []);
    const containerLinkId = useContainer(deep);
    const audioRecordingStatus = useRecordingStatus({});
    const sounds = useRecordingCycle({ deep, recording, containerLinkId, duration: 5000 });
    const startTime = useRef('');
    return _jsxs(Stack, { children: [_jsxs(Card, { children: [_jsx(CardHeader, { children: _jsx(Heading, { children: "Ability to record" }) }), _jsx(CardBody, { children: _jsx(Text, { children: `Device is ${!canDeviceRecord ? 'not' : ""} able to record.` }) })] }), _jsxs(Card, { children: [_jsx(CardHeader, { children: _jsx(Heading, { children: "Permissions" }) }), _jsxs(CardBody, { children: [_jsx(Text, { children: `Permissions are ${!arePermissionsGranted ? 'not' : ""} granted.` }), _jsx(Button, { onClick: async () => {
                                    const { value: arePermissionsGranted } = await CapacitorVoiceRecorder.requestAudioRecordingPermission();
                                    setArePermissionsGranted(arePermissionsGranted);
                                }, children: "Request permissions" })] })] }), _jsx(Card, { children: _jsx(CardHeader, { children: _jsx(Heading, { children: `Audio Recording Status: ${audioRecordingStatus}` }) }) }), _jsx(Card, { children: _jsx(CardHeader, { children: _jsx(Heading, { children: `Container Link Id: ${containerLinkId}` }) }) }), _jsx(Button, { onClick: async () => startTime.current = await startRecording(), children: "START RECORDING" }), _jsx(Button, { onClick: async () => await stopRecording({ deep, containerLinkId, startTime: startTime.current }), children: "STOP RECORDING" }), _jsx(Button, { onClick: () => setRecording(true), children: "START RECORDING CYCLE" }), _jsx(Button, { onClick: () => setRecording(false), children: "STOP RECORDING CYCLE" }), _jsx(Button, { onClick: async () => setRecords(await downloadRecords(deep)), children: "DOWNLOAD RECORDS" }), records?.map((r) => _jsx("audio", { controls: true, src: `data:${r.mimetype};base64,${r.sound}` }, Math.random().toString()))] });
}
