import { useEffect } from 'react';
import { useLocalStore } from '@deep-foundation/store/local';
import { createContainer } from '../create-container';
export const useContainer = (deep) => {
    const [containerLinkId, setContainerLinkId] = useLocalStore('containerLinkId', undefined);
    useEffect(() => {
        if (!containerLinkId) {
            const initializeContainerLink = async () => {
                setContainerLinkId(await createContainer(deep));
            };
            initializeContainerLink();
        }
    }, [deep]);
    return containerLinkId;
};
