import { useState, useEffect } from 'react';
import { VoiceRecorder } from "capacitor-voice-recorder";
import { uploadRecords } from '../upload-records';
export const delay = (time) => new Promise(res => setTimeout(() => res(), time));
export function useRecordingCycle({ deep, recording, containerLinkId, duration }) {
    const [records, setRecords] = useState([]);
    useEffect(() => {
        const useRecords = async () => {
            await uploadRecords({ deep, containerLinkId, records });
            setRecords([]);
        };
        if (records.length > 0)
            useRecords();
    }, [records]);
    useEffect(() => {
        let loop = true;
        const startRecordingCycle = async () => {
            for (; recording && loop;) {
                VoiceRecorder.startRecording();
                const startTime = new Date().toLocaleDateString();
                await delay(duration);
                const { value: sound } = await VoiceRecorder.stopRecording();
                const endTime = new Date().toLocaleDateString();
                setRecords([...records, { sound, startTime, endTime }]);
            }
        };
        if (recording)
            startRecordingCycle();
        return function stopCycle() { loop = false; };
    }, [recording]);
    return records;
}
